# Load lpSolve
library(lpSolve)

M = 10^(-8)
IM = matrix(c(1,0,0,0,
            0,1,0,0,
            0,0,1,0,
            0,0,0,1,
            1,1,0,0,
            1,0,1,0,
            1,0,0,1,
            0,1,1,0,
            1,1,1,0), ncol = 4, byrow = T)
souctova = rep(1,times = 4)
nulova = diag(4)
B = c(rep(M, times = nrow(IM)-1), 1, 0.13,0.4, rep(M, times = 2))
constranints_direction = c (">=",">=",">=",">=",">=",">=",">=",">=",
                            "=",
                            "=","=",">=",">=")

##inicializace matice reseni
typ = c("fix.1.max3","fix.1.min3",
        "fix.2.max3","fix.2.min3",
        "fix.3.max3","fix.3.min3",
        "fix.4.max3","fix.4.min3",
        "fix.12.max3","fix.12.min3",
        "fix.13.max3","fix.13.min3",
        "fix.14.max3","fix.14.min3",
        "fix.23.max3","fix.23.min3",
        "fix.123.max3","fix.123.min3",
        
        "fix.1.max4","fix.1.min4",
        "fix.2.max4","fix.2.min4",
        "fix.3.max4","fix.3.min4",
        "fix.4.max4","fix.4.min4",
        "fix.12.max4","fix.12.min4",
        "fix.13.max4","fix.13.min4",
        "fix.14.max4","fix.14.min4",
        "fix.23.max4","fix.23.min4",
        "fix.123.max4","fix.123.min4"
        )
status = rep(NA, times = 4*nrow(IM))
v1 = rep(0.13, times = 4*nrow(IM))
v2 = rep(0.4, times = 4*nrow(IM))
v3 = rep(NA, times = 4*nrow(IM))
v4 = rep(NA, times = 4*nrow(IM))
reseni = data.frame(typ, status, v1, v2, v3,v4)
## max / min v3
C = c(0,0,1,0)
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova)
  
  optimum.min = lp(direction="min",
                objective.in = C,
                const.mat = A,
                const.dir = constranints_direction,
                const.rhs = B,
                all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1] = optimum.max$status
  reseni$status[2*i] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
  reseni$v3[2*i-1] = optimum.max$solution[3]
  reseni$v3[2*i] = optimum.min$solution[3]
  reseni$v4[2*i-1] = optimum.max$solution[4]
  reseni$v4[2*i] = optimum.min$solution[4]    
  }
}
## max / min v4
C = c(0,0,0,1)
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova)
  
  optimum.min = lp(direction="min",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1 + 18] = optimum.max$status
  reseni$status[2*i +18] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
    reseni$v3[2*i-1+18] = optimum.max$solution[3]
    reseni$v3[2*i+18] = optimum.min$solution[3]
    reseni$v4[2*i-1+18] = optimum.max$solution[4]
    reseni$v4[2*i+18] = optimum.min$solution[4]    
  }
}
