# Load lpSolve
library(lpSolve)

M = 10^(-3)
IM = matrix(c(1,0,0,1), ncol = 2, byrow = T)
souctova = rep(1,times = ncol(IM))
nulova = diag(ncol(IM))
B = c(rep(M, times = nrow(IM)-1), 1, rep(M, times = ncol(IM)))
constranints_direction = c (">=",
                            "=",
                            ">=",">=")
A=rbind(IM, souctova, nulova)
##inicializace reseni
typ = c("dve.1.max1", "dve.1.min1","dve.2.max1","dve.2.min1",
        "dve.1.max2", "dve.1.min2","dve.2.max2","dve.2.min2")
smer = rep(c("max","min"), times = 2*nrow(IM))
status = rep(NA, times = 4*nrow(IM))
v1 = rep(NA, times = 4*nrow(IM))
v2 = rep(NA, times = 4*nrow(IM))
reseni = data.frame(typ, smer, status, v1, v2)
##reseni pro vechny typy indiferennch td (dv vhy)
## max / min v1
C = c(1,0)
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova)
  
  optimum.min = lp(direction="min",
                objective.in = C,
                const.mat = A,
                const.dir = constranints_direction,
                const.rhs = B,
                all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1] = optimum.max$status
  reseni$status[2*i] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
  reseni$v1[2*i-1] = optimum.max$solution[1]
  reseni$v1[2*i] = optimum.min$solution[1]
  reseni$v2[2*i-1] = optimum.max$solution[2]
  reseni$v2[2*i] = optimum.min$solution[2]
  }
}
## max / min v2
C = c(0,1)
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova)
  
  optimum.min = lp(direction="min",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1+4] = optimum.max$status
  reseni$status[2*i+4] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
    reseni$v1[2*i-1+4] = optimum.max$solution[1]
    reseni$v1[2*i+4] = optimum.min$solution[1]
    reseni$v2[2*i-1+4] = optimum.max$solution[2]
    reseni$v2[2*i+4] = optimum.min$solution[2]
  }
}