# Load lpSolve
library(lpSolve)

M = 10^(-3)
IM = matrix(c(1,0,0,
            0,1,0,
            0,0,1,
            1,0,1,
            0,1,1), ncol = 3, byrow = T)
souctova = rep(1,times = 3)
nulova = diag(3)
B = c(rep(M, times = nrow(IM)-1), 1, 0.2, rep(M, times = 2))
constranints_direction = c (">=",">=",">=",">=",
                            "=",
                            "=",">=",">=")

##inicializace matice reseni
typ = c("fix.1.max2","fix.1.min2",
        "fix.2.max2","fix.2.min2",
        "fix.3.max2","fix.3.min2",
        "fix.13.max2","fix.13.min2",
        "fix.23.max2","fix.23.min2",
        "fix.1.max3","fix.1.min3",
        "fix.2.max3","fix.2.min3",
        "fix.3.max3","fix.3.min3",
        "fix.13.max3","fix.13.min3",
        "fix.23.max3","fix.23.min3")
status = rep(NA, times = 4*nrow(IM))
v1 = rep(0.2, times = 4*nrow(IM))
v2 = rep(NA, times = 4*nrow(IM))
v3 = rep(NA, times = 4*nrow(IM))
reseni = data.frame(typ, status, v1, v2, v3)
## max / min v2
C = c(0,1,0)
i=1
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova)
  
  optimum.min = lp(direction="min",
                objective.in = C,
                const.mat = A,
                const.dir = constranints_direction,
                const.rhs = B,
                all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1] = optimum.max$status
  reseni$status[2*i] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
  reseni$v2[2*i-1] = optimum.max$solution[2]
  reseni$v2[2*i] = optimum.min$solution[2]
  reseni$v3[2*i-1] = optimum.max$solution[3]
  reseni$v3[2*i] = optimum.min$solution[3]    
  }
}
## max / min v3
C = c(0,0,1)
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova)
  
  optimum.min = lp(direction="min",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1 + 10] = optimum.max$status
  reseni$status[2*i +10] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
    reseni$v2[2*i-1+10] = optimum.max$solution[2]
    reseni$v2[2*i+10] = optimum.min$solution[2]
    reseni$v3[2*i-1+10] = optimum.max$solution[3]
    reseni$v3[2*i+10] = optimum.min$solution[3]    
  }
}
