# Load lpSolve
library(lpSolve)

M = 10^(-3)
IM = matrix(c(1,0,0,
            0,1,0,
            0,0,1,
            1,0,1,
            0,1,1), ncol = 3, byrow = T)
souctova = rep(1,times = ncol(IM))
nulova = diag(ncol(IM))
hodnoty = matrix(c(1/2,1,0,
                   1/2,0,1), byrow = T, ncol = ncol(IM))
B = c(rep(M, times = nrow(IM)-1), 1, rep(M, times = ncol(IM)), 1/2, 1/2)
constranints_direction = c (">=",">=",">=",">=",
                            "=",
                            ">=",">=",">=",
                            "=","=")
##inicializace reseni
typ = c("roz.1.max1","roz.1.min1","roz.2.max1","roz.2.min1",
        "roz.3.max1","roz.3.min1","roz.13.max1","roz.13.min1",
        "roz.23.max1","roz.23.min1",
        
        "roz.1.max2","roz.1.min2","roz.2.max2","roz.2.min2",
        "roz.3.max2","roz.3.min2","roz.13.max2","roz.13.min2",
        "roz.23.max2","roz.23.min2",
        
        "roz.1.max3","roz.1.min3","roz.2.max3","roz.2.min3",
        "roz.3.max3","roz.3.min3","roz.13.max3","roz.13.min3",
        "roz.23.max3","roz.23.min3")
status = rep(NA, times = 6*nrow(IM))
v1 = rep(NA, times = 6*nrow(IM))
v2 = rep(NA, times = 6*nrow(IM))
v3 = rep(NA, times = 6*nrow(IM))
reseni = data.frame(typ, status, v1, v2, v3)

C = c(1,0,0)
## max / min v1
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova, hodnoty)
  
  optimum.min = lp(direction="min",
                objective.in = C,
                const.mat = A,
                const.dir = constranints_direction,
                const.rhs = B,
                all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1] = optimum.max$status
  reseni$status[2*i] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
  reseni$v1[2*i-1] = optimum.max$solution[1]
  reseni$v1[2*i] = optimum.min$solution[1]
  reseni$v2[2*i-1] = optimum.max$solution[2]
  reseni$v2[2*i] = optimum.min$solution[2]
  reseni$v3[2*i-1] = optimum.max$solution[3]
  reseni$v3[2*i] = optimum.min$solution[3]    
  }
}

C = c(0,1,0)
## max / min v2
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova, hodnoty)
  
  optimum.min = lp(direction="min",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1+10] = optimum.max$status
  reseni$status[2*i+10] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
    reseni$v1[2*i-1+10] = optimum.max$solution[1]
    reseni$v1[2*i+10] = optimum.min$solution[1]
    reseni$v2[2*i-1+10] = optimum.max$solution[2]
    reseni$v2[2*i+10] = optimum.min$solution[2]
    reseni$v3[2*i-1+10] = optimum.max$solution[3]
    reseni$v3[2*i+10] = optimum.min$solution[3]    
  }
}

C = c(0,0,1)
## max / min v3
for (i in 1:nrow(IM)){
  d = matrix(rep(IM[i,], times = nrow(IM)-1),byrow = T, ncol = ncol(IM))
  IM.bezmax = IM[-i,]
  IM.minus = d - IM.bezmax
  A = rbind(IM.minus, souctova, nulova, hodnoty)
  
  optimum.min = lp(direction="min",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F)
  
  optimum.max = lp(direction="max",
                   objective.in = C,
                   const.mat = A,
                   const.dir = constranints_direction,
                   const.rhs = B,
                   all.int = F) 
  
  reseni$status[2*i-1+20] = optimum.max$status
  reseni$status[2*i+20] = optimum.min$status
  if (optimum.max$status == 0 && optimum.min$status == 0){
    reseni$v1[2*i-1+20] = optimum.max$solution[1]
    reseni$v1[2*i+20] = optimum.min$solution[1]
    reseni$v2[2*i-1+20] = optimum.max$solution[2]
    reseni$v2[2*i+20] = optimum.min$solution[2]
    reseni$v3[2*i-1+20] = optimum.max$solution[3]
    reseni$v3[2*i+20] = optimum.min$solution[3]    
  }
}